var basePanel;
var editorWindow;
var selectedItem;
var columnDef;
var selectedId;
var saveCallback;
var deleteCallback;


function showWaitDialog(message)
{
	Ext.MessageBox.show({
        msg: message,
        progressText: 'Initializing...',
        width:300,
        progress:true,
        closable:false
    });
}

function hideWaitDialog()
{
	Ext.MessageBox.hide();
}

function updateWaitDialog(percentage,message)
{
	Ext.MessageBox.updateProgress(percentage, message);
}

/*
 * fkt speichert Properties mit mehreren Aktionen gleichzeitig
 * oPropsArray: {   path:'////',
 *     value:value,
 *     message:'huhu'}
 *     
 *  saveEvent: { name:'xxx',parameter:{} }
 *  
 *  finishAction: FKT wird nach dem Speichern aufgerufen
 *  
 * */

function stepProps(oPropsArray,saveEvent,finishAction,iStep)
{
	var iMax=(oPropsArray.length*2+1) *1.0;
	if (iStep<(oPropsArray.length*2))
	{
		var iPropsIndex=Math.floor(iStep/2);
		var oPropProperty=oPropsArray[iPropsIndex];
		if ((iStep%2)==0)
		{
			var sURL="";
			var sPfad=escape(oPropProperty.path);
			
			if (typeof(oPropProperty.value)=="number")
			{
				sURL='/json/property/setInteger';// ?path=' + sPfad + "&value=" +
													// (sValue);
			} else { 
				if (typeof(oPropProperty.value)=="boolean")
					sURL='/json/property/setBoolean';// ?path=' + sPfad + "&value=" +
														// (sValue);
				 else 
					sURL='/json/property/setString';// ?path=' + sPfad + "&value=" +
													// (sValue);
				
			}
			window.setTimeout(function() {
			ajaxAssyncRequestWithoutAnswer(sURL,{'path':sPfad,'value': (oPropProperty.value)},
				function() {
					stepProps(oPropsArray,saveEvent,finishAction,iStep+1);
				}
			);},1);
			updateWaitDialog(iStep/iMax,oPropProperty.message);
		} else {
			var sURL='/json/property/setFlag';
			var sPfad=escape(oPropProperty.path);
			window.setTimeout(function() {
			ajaxAssyncRequestWithoutAnswer(sURL,{'path':sPfad,'value': 'true','flag':'ARCHIVE'},
				function() {
					stepProps(oPropsArray,saveEvent,finishAction,iStep+1);
				}
			);},1);
			
			updateWaitDialog(iStep/iMax,oPropProperty.message);
		}
	} else 
	if (iStep==(oPropsArray.length*2)) {
		
		var sURL='/json/event/raise';	
		var paramString="";
		for (var key in saveEvent.parameter)
		{
			paramString += key + "=" + encodeURIComponent(saveEvent.parameter[key]) + ";";
		}	
		window.setTimeout(function() {
		ajaxAssyncRequestWithoutAnswer(sURL,{'name':saveEvent.name,'parameter':paramString.substr(0,paramString.length-1)},
			function() {
				stepProps(oPropsArray,saveEvent,finishAction,iStep+1);
			}
		);},1);
		updateWaitDialog(iStep/iMax,saveEvent.message);			
	} else {
		finishAction();
		hideWaitDialog();
	}
}

function bulkPropertySave(oPropsArray,saveEvent,finishAction)
{
	showWaitDialog('Speichere Daten');
	stepProps(oPropsArray,saveEvent,finishAction,0);
}


function getZoneStore()
{
	if (Ext.data.StoreManager.lookup('zoneStore')==null) {
		Ext.create('Ext.data.Store', {
			storeId : 'zoneStore',
			fields : ['ZoneID','name'],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});
		Ext.data.StoreManager.lookup('zoneStore').add(getZoneArray());
	}
	return Ext.data.StoreManager.lookup('zoneStore');
}

function getGroupStore(ZoneID)
{
	if (nameCache==null)
		initCaches();
	if (Ext.data.StoreManager.lookup('groupStore_'+ZoneID)==null)
	{
		Ext.create('Ext.data.Store', {
			storeId : 'groupStore_'+ZoneID,
			fields : ['group','name','icon','reachable'],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});
		var oGroup=getGroupForZone(ZoneID);
		Ext.data.StoreManager.lookup('groupStore_'+ZoneID).add(oGroup);
	}
	return Ext.data.StoreManager.lookup('groupStore_'+ZoneID);
}

function getSceneStore(ZoneID,groupID)
{
	if (nameCache==null)
		initCaches();

	if (Ext.data.StoreManager.lookup('szeneStore_'+ZoneID + '_' + groupID)==null)
	{
		Ext.create('Ext.data.Store', {
			storeId : 'szeneStore_'+ZoneID+ '_' + groupID,
			fields : ['id','name','reachable','icon'],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});
		var oScenes=getScenes(ZoneID,groupID);
		Ext.data.StoreManager.lookup('szeneStore_'+ZoneID+ '_' + groupID).add(oScenes);
	}
	return Ext.data.StoreManager.lookup('szeneStore_'+ZoneID+ '_' + groupID);

}

function initAppDataStore(itemDev)
{
	Ext.create('Ext.data.Store', {
		storeId : 'appDataStore',
		fields : itemDev,
		proxy : {
			type : 'memory',
			reader : {
				type : 'json',
				root : 'items'
			}
		}
	});
}

function fillAppDataStore(data)
{
	Ext.data.StoreManager.lookup('appDataStore').removeAll();
	Ext.data.StoreManager.lookup('appDataStore').add(data);
}

function getDefaultRenderer(col)
{
	if (col.type=='trigger')
	{
		return function (val, metadata, record, colIdx, store, view)
		{
			var triggerObject = record.get(col.name);
			var sString="<table>";
			sString+="<tr><td>Raum:</td><td>" + getNameForZone(triggerObject.zone) + "</td></tr>";
			sString+="<tr><td>Farbe:</td><td>" + getImageForGroup(triggerObject.zone,triggerObject.group) + " " + getNameForGroup(triggerObject.zone,triggerObject.group) + "</td></tr>";
			sString+="<tr><td>Aktivit&auml;t:</td><td>" + getImageForScene(triggerObject.zone,triggerObject.group,triggerObject.scene) + " " + getNameForScene(triggerObject.zone,triggerObject.group,triggerObject.scene) + "</td></tr>";
			sString +="</table>";
			/*var sString=getImageForScene(triggerObject.zone,triggerObject.group,triggerObject.scene) + " " + getNameForScene(triggerObject.zone,triggerObject.group,triggerObject.scene);
			sString+=" f&uuml;r " + getImageForGroup(triggerObject.zone,triggerObject.group) + " " + getNameForGroup(triggerObject.zone,triggerObject.group);
			sString+=" in " + getNameForZone(triggerObject.zone);*/
			return sString;
		}
	}
	else if (col.type=='message')
	{
		return function (val, metadata, record, colIdx, store, view)
		{			
			var triggerObject = record.get(col.name);
			if (triggerObject.messageType=='email')
				return '<table><tr><td rowspan="3"><image src="images/dss/email.png"></td>'+
				       '<td rowspan="3" style="width:5px;"><image src="t.gif"></td>' + 
					   '<td>Empf&auml;nger:</td><td>'+ triggerObject.receiver +'</td></tr>'+
					   '<tr><td>Betreff:</td><td>' +triggerObject.subject+ '</td></tr>'+
					   '<tr><td>Nachricht:</td><td>'+ triggerObject.message+'</td></tr></table>';
			else
				return "eine Nachricht";
		}
	}
	/*else if (col.type='action')
	{
		return function(val, metadata, record, colIdx, store, view) {
            var actions = record.get(col.name),
                num = actions.getCount(),
                res = [],
                i = 0;
            for (; i < num; ++i) {
                res.push(actions.getAt(i).get('text'));
            }
            return res.join('<br>');
        }
	}*/
	return null;
}

function makeBasePanel(colDef,saveFunction,deleteFunction) {
	columnDef=colDef;
	saveCallback=saveFunction;
	deleteCallback=deleteFunction;
	var contentBereich = document.getElementById('myExtContent');

	var oColumnDef = [ {
		id : 'col-status',
		header : 'Aktiv',
		dataIndex : 'disabled',
		renderer : function(disabled) {
			return '<input type="checkbox" disabled="true"'
					+ (!disabled ? ' checked="true">' : '>');
		},
		resizable : false,
		hideable:false,
		width : 50
	} ];
	for ( var iIndex = 0; iIndex < colDef.length; iIndex++) {
		var col = colDef[iIndex];
		var object = {
			id : 'col-' + col.name,
			header : col.title,
			dataIndex : col.name,
			hideable:false,
			flex : 1
		}
		if (col.renderfkt!=null)
			object.renderer = col.renderfkt;
		else
			object.renderer = getDefaultRenderer(col);
		oColumnDef.push(object);
	}

	var gridPanel = Ext.create('Ext.grid.Panel', {

		store : Ext.data.StoreManager.lookup('appDataStore'),
		columns : oColumnDef,
		region : 'center',
		border:0,
		enableColumnHide:false,
		viewConfig: {
	        stripeRows: true
	    },
	    tbar: {
	        items: [{
	            text: baseValues.newEntry,
	            id: 'btn-add',
	            iconCls: 'icon-add-action',
	            handler: newItem
	        }, {
	            text: baseValues.editEntry,
	            id: 'btn-edit',
	            iconCls: 'icon-edit-action',
	            disabled: true,
	            handler: editItem
	        }, {
	            text: baseValues.disableEntry,
	            id: 'btn-disable',
	            iconCls: 'icon-stop-action',
	            disabled: true,
	            handler: disableItem
	        }, {
	            text: baseValues.enableEntry,
	            id: 'btn-enable',
	            iconCls: 'icon-start-action',
	            hidden: true,
	            disabled: true,
	            handler: enableItem
	        }, '->', {
	            text: baseValues.deleteEntry,
	            id: 'btn-delete',
	            iconCls: 'icon-delete-action',
	            disabled: true,
	            handler: deleteItem
	        }]
	    }	
	});
	gridPanel.on({
        selectionchange: function(view, selections, options) {
            if (selections.length > 0) {
            	selectedItem = selections[0];
            	selectedId=selectedItem.get('id');
                Ext.getCmp('btn-edit').setDisabled(false);
                Ext.getCmp('btn-delete').setDisabled(false);
                Ext.getCmp('btn-disable').setDisabled(selectedItem.get('disabled'));
                Ext.getCmp('btn-enable').setDisabled(!selectedItem.get('disabled'));
                Ext.getCmp('btn-disable').setVisible(!selectedItem.get('disabled'));
                Ext.getCmp('btn-enable').setVisible(selectedItem.get('disabled'));
            } else {
            	selectedItem = null;
            	selectedId=-1;
                Ext.getCmp('btn-edit').setDisabled(true);
                Ext.getCmp('btn-disable').setDisabled(true);
                Ext.getCmp('btn-delete').setDisabled(true);
                Ext.getCmp('btn-enable').setDisabled(true);
                Ext.getCmp('btn-enable').setVisible(false);
            }
        }
    });
	contentBereich.innerHTML="";
	basePanel = Ext.create('Ext.panel.Panel', {
		renderTo : contentBereich,
		

		layout : {
			type : 'border'
		},
		height:contentBereich.clientHeight,
		items : [ gridPanel, {
			region : 'south',
			title : 'Hilfe',
			xtype : 'panel',
			height : 200,
			minHeight : 200,
			layout : 'fit',
			collapsible : true,
			collapsed : true,
			split : true
		// enable resizing
		} ]
	});
	Ext.EventManager.onWindowResize(function() {
	    // pass "true" to get the contendWidth (excluding border/padding/etc.)
		basePanel.setHeight(document.getElementById('myExtContent').clientHeight);
	    // seems to be no need to call mainPanel.doLayout() here in my situation
	});
	
	
	
	var editorPanel= Ext.create('Ext.form.Panel',{
		bodyPadding: 5,
		border:0,
		buttons: [
               {
                	text: 'Abbruch',
                    handler: function() {
                    	editorWindow.hide();
                    }
                }, {
                    text: 'Speichern',
                    handler: function() {
                    	var fValid=true;
                    	for (var sKey in editorWindow.editControls)
                    	{
                    		var oControl=editorWindow.editControls[sKey];
                    		
                    		if (oControl.isValid!=null)
                    			if (!oControl.isValid())
                    				fValid=false;
                    	}
                    	if (fValid) {
	                    	saveCallback(getObjectData());
	                    	editorWindow.hide();
                    	}
                    }
                }
            ]
	});
	
	editorWindow  = Ext.create('Ext.window.Window', {
        closeAction: 'hide',
        title: baseValues.editorTitle,
        modal: true, // Exclusive input for the window
        width: 525,
        layout: 'fit',
        items:[editorPanel]
    });
	
	editorWindow.editControls={};
	var iHeight=75;
	for ( var iIndex = 0; iIndex < colDef.length; iIndex++) {
		var col = colDef[iIndex];
		if (col.type=='string') {
			var oControl=Ext.create('Ext.form.field.Text',{
				name:'edit_' + col.name,
				fieldLabel:col.title,
				allowBlank: false,
				width:500,
				labelWidth:80,
				blankText:col.title + ' muss ausgef&uuml;llt werden',
				invalidText:col.title + ' muss ausgef&uuml;llt werden'
				});
			editorPanel.add(oControl);
			editorWindow.editControls[col.name]=oControl;			
			iHeight+=27;
		} else
		if (col.type=='trigger') {
				      			
			var oControlZoneCombo=Ext.create('Ext.form.field.ComboBox',
			{
				fieldLabel:'Raum',
				store:getZoneStore(),
				queryMode:'local',
				displayField:'name',
				valueField:'ZoneID',
				labelWidth:68,
				allowBlank:false,
				blankText:'Ein Raum muss gew&auml;hlt werden',
				invalidText:'Ein Raum muss gew&auml;hlt werden',
				listConfig: {
			        maxHeight:300
				},
				editable:false
			});
			
			
			var oGroupStore=Ext.create('Ext.data.Store', {
				fields : ['group','name','icon'],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
			
			var tplGroup = new Ext.XTemplate(
				    '<img src="{icon}"> {name}'
			);
			
			var oControlGroupCombo=Ext.create('Ext.form.field.ComboBox',
			{
				fieldLabel:'Gruppe',
				store:oGroupStore,
				queryMode:'local',
				listConfig: {
			        getInnerTpl: function() {
			        	return '<div><img src="{icon}"> {name}</div>';
			        },
			        maxHeight:300
				},
				valueField:'group',
				labelWidth:68,
				displayField:'name',
				disabled:true,
	            forceSelection: true,
				editable:false,
				allowBlank:false,
				blankText:'Eine Gruppe muss gew&auml;hlt werden',
				invalidText:'Eine Gruppe muss gew&auml;hlt werden'
			});		
			
			var oSceneStore=Ext.create('Ext.data.Store', {
				fields : ['id','name','reachable','icon'],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});

			var oControlSceneCombo=Ext.create('Ext.form.field.ComboBox',
			{
				fieldLabel:'Aktivit&auml;t',
				store:oSceneStore,
				queryMode:'local',
				displayField:'name',
				valueField:'id',
				labelWidth:68,
				tpl:'<div><img src="{icon}"> {name}</div>',				
				listConfig: {
			        getInnerTpl: function() {
			        	return '<div><img src="{icon}"> {name}</div>';
			        },
			        maxHeight:300
				},
				disabled:true,
				allowBlank:false,
				blankText:'Eine Aktivit&auml;t muss gew&auml;hlt werden',
				invalidText:'Eine Aktivit&auml;t muss gew&auml;hlt werden',
				editable:false
			});
			
			var oControlCheckAll=Ext.create('Ext.form.field.Checkbox',
			{
				boxLabel:'alle Gruppen/Aktivit&auml;ten anzeigen'
			});
			
			var targetPanel=Ext.create('Ext.form.Panel',
			{
				height:50,
				columnWidth: 0.5,
				border:0,
				items:[oControlZoneCombo,oControlGroupCombo]			
			}
			);
			
			var actionPanel=Ext.create('Ext.form.Panel',
			{
				height:50,
				columnWidth: 0.5,
				border:0,
				items:[oControlSceneCombo,oControlCheckAll]
			}
			);
			
			editorWindow.editControls[col.name+'_zoneCombo']=oControlZoneCombo;
			editorWindow.editControls[col.name+'_groupCombo']=oControlGroupCombo;
			editorWindow.editControls[col.name+'_sceneCombo']=oControlSceneCombo;
			editorWindow.editControls[col.name+'_checkAll']=oControlCheckAll;
			
			oControlZoneCombo.on('select', onSetZoneBox,oControlZoneCombo,{zoneBox:oControlZoneCombo,groupBox:oControlGroupCombo,sceneBox:oControlSceneCombo,checkBox:oControlCheckAll});
			
			oControlGroupCombo.on('select', onSetGroupBox,oControlGroupCombo,{zoneBox:oControlZoneCombo,groupBox:oControlGroupCombo,sceneBox:oControlSceneCombo,checkBox:oControlCheckAll});
			
			oControlSceneCombo.on('select', function(field, value, options) {
	            var bg = 'background:none;';
	            var icon = (value.length > 0 ? value[0].get('icon') : null);
	            if (icon) {	                
	                bg = "background:left center no-repeat url('"+ icon +"');";
	            }
	            field.setFieldStyle(bg + 'padding-left:21px;');
	        });
			
			oControlCheckAll.on('change', function (field, newValue,oldValue, ComboControls)
					{
						var ZoneID=ComboControls.zoneBox.getValue();
						var GroupID=ComboControls.groupBox.getValue();
						var fShouldBeFiltered=!oControlCheckAll.getValue();
						
						var oGroupStore=getGroupStore(ZoneID);
						var oGroupControlStore=ComboControls.groupBox.store;
						oGroupControlStore.removeAll();
						oGroupStore.each(function(record){
							var oNewRecord=record.copy()
							if (oNewRecord.get('reachable') || (!fShouldBeFiltered))
								oGroupControlStore.add(oNewRecord);
						});	
												
						var oSceneStore=getSceneStore(ZoneID,GroupID);
						var oSceneControlStore=ComboControls.sceneBox.store;
						oSceneControlStore.removeAll();
						oSceneStore.each(function(record){
							var oNewRecord=record.copy();
							if (oNewRecord.get('reachable') || (!fShouldBeFiltered))
								oSceneControlStore.add(oNewRecord);
						});
						ComboControls.sceneBox.createPicker(); 									
					},oControlGroupCombo,{zoneBox:oControlZoneCombo,groupBox:oControlGroupCombo,sceneBox:oControlSceneCombo,checkBox:oControlCheckAll});
			
			var oControlGroup=Ext.create('Ext.form.FieldSet',{
				title:'Ausl&ouml;sende Aktivit&auml;t',
				width:500,
				height:90,
				layout:'column',
				border:0,
				items: [
					targetPanel,
					actionPanel
				]
			});
			editorWindow.editControls[col.name]=oControlGroup;
			editorPanel.add(oControlGroup);
			iHeight+=100;

		} else
		if (col.type=='message') {
			var oControlGroup=Ext.create('Ext.form.FieldSet',{
				title:col.title,
				width:500
			});
			var oControlRec=Ext.create('Ext.form.field.Text',{
				name:'edit_' + col.name + '_receiver',
				fieldLabel:'Empf&auml;nger',
				allowBlank: false,
				width:450,
				labelWidth:68,
				regex:/\b[A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i,
				regexText:'Die Emailadresse ist fehlerhaft',
				blankText:'Die Emailadresse muss ausgef&uuml;llt werden',
				invalidText:'Die Emailadresse muss ausgef&uuml;llt werden'
				});
			var oControlSubject=Ext.create('Ext.form.field.Text',{
				name:'edit_' + col.name + '_subject',
				fieldLabel:'Betreff',
				allowBlank: false,
				width:450,
				labelWidth:68,
				blankText:'Betreff muss ausgef&uuml;llt werden',
				invalidText:'Betreff muss ausgef&uuml;llt werden'
				});
			var oControlBody=Ext.create('Ext.form.field.TextArea',{
				name:'edit_' + col.name + '_body',
				fieldLabel:'Inhalt',
				allowBlank: false,
				width:450,
				height:60,
				labelWidth:68,
				blankText:'Inhalt muss ausgef&uuml;llt werden',
				invalidText:'Inhalt muss ausgef&uuml;llt werden'
				});
			oControlGroup.add(oControlRec);
			oControlGroup.add(oControlSubject);
			oControlGroup.add(oControlBody);
			editorPanel.add(oControlGroup);
			editorWindow.editControls[col.name]=oControlGroup;			
			editorWindow.editControls[col.name + '_receiver']=oControlRec;			
			editorWindow.editControls[col.name + '_subject']=oControlSubject;			
			editorWindow.editControls[col.name + '_body']= oControlBody;			
			iHeight+=166;
		} 
	}
	
	editorWindow.setHeight(iHeight);
	basePanel.setHeight(document.getElementById('myExtContent').clientHeight);
}

function onSetZoneBox(combo, records, ComboControls)
{
	var ZoneID=ComboControls.zoneBox.getValue();

	var oGroupStore=getGroupStore(ZoneID);
	var oGroupControlStore=ComboControls.groupBox.store;
	var fShouldBeFiltered=!ComboControls.checkBox.getValue();
	oGroupControlStore.removeAll();
	oGroupStore.each(function(record){
		var oNewRecord=record.copy()
		if (oNewRecord.get('reachable') || (!fShouldBeFiltered))
			oGroupControlStore.add(oNewRecord);
	});						
	ComboControls.groupBox.setDisabled(false);
	ComboControls.groupBox.setValue(null);
	ComboControls.sceneBox.setDisabled(true);
	ComboControls.sceneBox.setValue(null);
    ComboControls.groupBox.setFieldStyle('background:none;');
    ComboControls.sceneBox.setFieldStyle('background:none;');
}

function onSetGroupBox(combo, records, ComboControls)
{
	var ZoneID=ComboControls.zoneBox.getValue();
	var GroupID=ComboControls.groupBox.getValue();
	
	var oSceneStore=getSceneStore(ZoneID,GroupID);
	var oSceneControlStore=ComboControls.sceneBox.store;
	var fShouldBeFiltered=!ComboControls.checkBox.getValue();
	oSceneControlStore.removeAll();
	oSceneStore.each(function(record){
		var oNewRecord=record.copy();							
		if (oNewRecord.get('reachable') || (!fShouldBeFiltered))
			oSceneControlStore.add(oNewRecord);
	});
	ComboControls.sceneBox.setDisabled(false);
	ComboControls.sceneBox.setValue(null);
	if (combo!=null)
		ComboControls.sceneBox.createPicker(); 			
	
	var bg = 'background:none;';
    var icon = getImagePathForGroup(ZoneID,GroupID);
    if (icon) {			                
        bg = "background:left center no-repeat url('"+ icon +"');";
    }
    ComboControls.groupBox.setFieldStyle(bg + 'padding-left:21px;');
    ComboControls.sceneBox.setFieldStyle('background:none;');	
}

function getObjectData()
{
	var oNewObject={};
	for ( var iIndex = 0; iIndex < columnDef.length; iIndex++) {
		var col = columnDef[iIndex];
		if (col.type=='string') {
			var oTextControl=editorWindow.editControls[col.name];
			oNewObject[col.name]=oTextControl.getValue();
		} else
		if (col.type=='trigger') {
			var oZoneControl=editorWindow.editControls[col.name+'_zoneCombo'];
			var oGroupControl=editorWindow.editControls[col.name+'_groupCombo'];
			var oSzeneControl=editorWindow.editControls[col.name+'_sceneCombo'];
			oNewObject[col.name]={
				'zone':oZoneControl.getValue(), 
				'group':oGroupControl.getValue(),
				'scene':oSzeneControl.getValue()
			}
		} else
		if (col.type=='message') {
			var oControlRec = editorWindow.editControls[col.name + '_receiver'];			
			var oControlSubject = editorWindow.editControls[col.name + '_subject'];			
			var oControlBody = editorWindow.editControls[col.name + '_body'];
			oNewObject[col.name]={
					messageType:"email",
					receiver:oControlRec.getValue(),
					subject:oControlSubject.getValue(),
					message:oControlBody.getValue()
			};	
		}
	}
	if (selectedId==-1){
		var iMaxID=0;
		Ext.data.StoreManager.lookup('appDataStore').each(function (oRec){
			if (iMaxID<oRec.get('id'))
				iMaxID=oRec.get('id');
		});
		oNewObject.id=iMaxID+1;
		oNewObject.disabled=false;
	} else {
		oNewObject.id=selectedId;
		oNewObject.disabled=selectedItem.get("disabled");
	}
	
	return oNewObject;
}

function getObjectDataFromSelection()
{
	var oNewObject={};
	for ( var iIndex = 0; iIndex < columnDef.length; iIndex++) {
		var col = columnDef[iIndex];
		var dataFragment=selectedItem.get(col.name);
		
		if (col.type=='string') {
			oNewObject[col.name]=dataFragment
		} else
		if (col.type=='trigger') {
			oNewObject[col.name]={
				'zone':dataFragment.zone, 
				'group':dataFragment.group,
				'scene':dataFragment.scene
			}
		} else
		if (col.type=='message') {
			oNewObject[col.name]={
					messageType:"email",
					receiver:dataFragment.receiver,
					subject:dataFragment.subject,
					message:dataFragment.message
			};	
		}
	}
	if (selectedId==-1){
		var iMaxID=0;
		Ext.data.StoreManager.lookup('appDataStore').each(function (oRec){
			if (iMaxID<oRec.get('id'))
				iMaxID=oRec.get('id');
		});
		oNewObject.id=iMaxID+1;
		oNewObject.disabled=false;
	} else {
		oNewObject.id=selectedId;
		oNewObject.disabled=selectedItem.get("disabled");
	}
	
	return oNewObject;
}

function setObjectData(oData)
{	
	for ( var iIndex = 0; iIndex < columnDef.length; iIndex++) {
		var col = columnDef[iIndex];
		var dataFragment=oData.get(col.name);
		if (col.type=='string') {
			var oTextControl=editorWindow.editControls[col.name];
			oTextControl.setValue(dataFragment);
		} else
		if (col.type=='trigger') {
			var oZoneControl=editorWindow.editControls[col.name+'_zoneCombo'];
			var oGroupControl=editorWindow.editControls[col.name+'_groupCombo'];
			var oSzeneControl=editorWindow.editControls[col.name+'_sceneCombo'];
			var oCheckControl=editorWindow.editControls[col.name+'_checkAll'];
			var Scenes=getScenes(dataFragment.zone,dataFragment.group);
			for (var jIndex=0;jIndex<Scenes.length;jIndex++)
				if (Scenes[jIndex].id==dataFragment.scene){
					oCheckControl.setRawValue(!Scenes[jIndex].reachable);
				}

			oZoneControl.setValue(dataFragment.zone);
			onSetZoneBox( null, null,{
				zoneBox:oZoneControl,
				groupBox:oGroupControl,
				sceneBox:oSzeneControl,
				checkBox:editorWindow.editControls[col.name+'_checkAll']});
			oGroupControl.setValue(dataFragment.group);
			
			onSetGroupBox(null, null, {
				zoneBox:oZoneControl,
				groupBox:oGroupControl,
				sceneBox:oSzeneControl,
				checkBox:editorWindow.editControls[col.name+'_checkAll']});

			oSzeneControl.setValue(dataFragment.scene);			
		    var bg = 'background:none;';
		    var icon=getImagePathForScene(dataFragment.zone,dataFragment.group,dataFragment.scene);
		    if (icon) {	                
		        bg = "background:left center no-repeat url('"+ icon +"');";
		    }
		    oSzeneControl.setFieldStyle(bg + 'padding-left:21px;');	
		} else
		if (col.type=='message') {
			var oControlRec = editorWindow.editControls[col.name + '_receiver'];			
			var oControlSubject = editorWindow.editControls[col.name + '_subject'];			
			var oControlBody = editorWindow.editControls[col.name + '_body'];
			oControlRec.setValue(dataFragment.receiver);
			oControlSubject.setValue(dataFragment.subject);
			oControlBody.setValue(dataFragment.message);
		}
	}

}

function newItem()
{
	selectedId=-1;
	
	for ( var iIndex = 0; iIndex < columnDef.length; iIndex++) {
		var col = columnDef[iIndex];
		if (col.type=='string') {
			var oTextControl=editorWindow.editControls[col.name];
			oTextControl.setRawValue(null);
		} else
		if (col.type=='trigger') {
			var oZoneControl=editorWindow.editControls[col.name+'_zoneCombo'];
			var oGroupControl=editorWindow.editControls[col.name+'_groupCombo'];
			var oSzeneControl=editorWindow.editControls[col.name+'_sceneCombo'];
			var oCheckControl=editorWindow.editControls[col.name+'_checkAll'];
			oCheckControl.setRawValue(false);
			
			oZoneControl.setRawValue(null);
			oGroupControl.setRawValue(null);
			oSzeneControl.setRawValue(null);			
		    var bg = 'background:none;';
		    oSzeneControl.setFieldStyle(bg + 'padding-left:21px;');
		    oGroupControl.setFieldStyle(bg + 'padding-left:21px;');
		    
		} else
		if (col.type=='message') {
			var oControlRec = editorWindow.editControls[col.name + '_receiver'];			
			var oControlSubject = editorWindow.editControls[col.name + '_subject'];			
			var oControlBody = editorWindow.editControls[col.name + '_body'];
			oControlRec.setRawValue(null);
			oControlSubject.setRawValue(null);
			oControlBody.setRawValue(null);
		}
	}
	
	editorWindow.show();
}


function editItem()
{
	if (selectedItem==null)
		return;
	selectedId=selectedItem.get('id');
	editorWindow.show();
	setObjectData(selectedItem);
}

function enableItem()
{
	if (selectedItem==null)
		return;
	selectedItem.set('disabled',false);
	saveCallback(getObjectDataFromSelection());
}

function disableItem()
{
	if (selectedItem==null)
		return;
	selectedItem.set('disabled',true);
	saveCallback(getObjectDataFromSelection());
}

function deleteItem()
{
	if (selectedItem==null)
		return;
	deleteCallback(getObjectDataFromSelection());
}